ndata = 1000;			% Number of data points.
x1 = unifrnd(0,1,1,ndata);
x2 = unifrnd(0,2,1,ndata);	
x=[x1;x2]';
tt = exp(1+1.2*sqrt(x(:,1))+ 0.25*sqrt(x(:,2)));
t= poissrnd(tt,ndata,1);

rand('state', 423);
randn('state', 423);
%create a training error martix
train_error=zeros(10,10);
test_error=zeros(10,10);
% Set up network parameters.

network = cell(10,10);


nin = 2;			% Number of inputs.
			% Number of hidden units.
nout = 1;			% Number of outputs.
alpha = 0.012;			% Coefficient of weight-decay prior. 


    for i=1:10
        nhidden = i*1 ;
        for j = 1 : 10
            
   net = mlp(nin, nhidden, nout, 'poisson', alpha);
   options = foptions;
            options(1)=1;
            options(2)=1e-5;
            options(3)=1e-5;
            options(14)=1000;
           
       [net]=netopt(net, options,x(1:900,:),t(1:900,:),'scg');

err=mlperr(net,x(1:900,:),t(1:900,:));
            train_error(i,j)=err;
       [nettrain]=netopt(net,options,x(901:1000,:),t(901:1000,:),'scg');
       
  test_error(i,j)=mlperr(nettrain,x(901:1000,:),t(901:1000,:));
  network{i,j}=net;
        
        network_valid{i,j}=nettrain;
       % [y,z]= mlpfwd(net,tes{j});
       % pred{i,j}=y;
        end;
    end;
    
    %%%%%%%%%%%Predictions%%%%%%%%%%%%%
    Index = 3;
Index_best = 3;

[trainy,trainz,traina] = mlpfwd(network_valid{Index,Index_best}, x(1:900,:));
[testy,testz,testa] = mlpfwd(network_valid{Index,Index_best},x(901:1000,:));

MSETest=sum((testy-tt(901:1000,1)).^2)/size(testy,1);

%%%%%Poissson Regression%%%%%%%%%%

[b,dev,stats] = glmfit(x(1:900,:),tt(1:900,1),'poisson');

yTrainhatPoiReg=stats.beta(1)+stats.beta(2)*x(1:900,1)+stats.beta(3)*x(1:900,2);
ytesthat=stats.beta(1)+stats.beta(2)*x(901:1000,1)+stats.beta(3)*x(901:1000,2);
MSETestPoiReg=sum((ytesthat-tt(901:1000,1)).^2)/size(testy,1);


%%%%%Comparision%%%%%

figure
subplot(2,2,1)       % add first plot in 2 x 2 grid
scatter(tt(1:900,1),yTrainhatPoiReg);
refline(1,0);         % line plot
title('Poisson Regression: Train Data')

subplot(2,2,2)       % add second plot in 2 x 2 grid
scatter(tt(1:900,1),trainy);
refline(1,0);        % scatter plot
title('ANN: Train Data')

subplot(2,2,3)       % add third plot in 2 x 2 grid
scatter(tt(901:1000,1),ytesthat);
refline(1,0);           % stem plot
title('Poisson Regression: Test Data')

subplot(2,2,4)       % add fourth plot in 2 x 2 grid
scatter(tt(901:1000,1),testy);
refline(1,0);
title('ANN: Test Data')

save testingPoisson.mat