%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%Simulation 4 in the Manuscrpit%%%%%%% 
%N=5000 Data Generation

x1 = unifrnd(0,1,1,5000);
x2 = unifrnd(0,1,1,5000);

lambda=exp(.5*exp(1+.2*x1).\ (1+exp(x2+1)));
hist(lambda);

t1=poissrnd(lambda,1,5000);

data=[x1' x2' t1'];

%Splitting the full data set into train and test sets
trainx=data(1:4000,1:end-1);
traint=data(1:4000,end);
testX=data(4001:5000,1:end-1);
testt=data(4001:5000,end);

rand('state',342);

%Cross Validation
indices = crossvalind('Kfold',traint,5);

trainkfold_x=cell(5,1);
trainkfold_t=cell(5,1);
validkfold_x=cell(5,1);
validkfold_t=cell(5,1);

%%Creating 5-folds using the training data
for i = 1:5
   test = (indices == i); train = ~test;
   trainkfold_x{i} = trainx(train,:);trainkfold_t{i} = traint(train,:); 
   validkfold_x{i}=trainx(test,:);validkfold_t{i}=traint(test,:);
end  
 
save Sim4DataGenerationN5000.mat
